## 使用
代理服务：sudo DBUS_SYSTEM_BUS_ADDRESS=tcp:host=localhost,port=11111 /usr/bin/dbusProxyTest 

代理服务：sudo /usr/bin/dbus-daemon-proxy --system --port 11111 --verbose --namespace mira

## 场景1
1.当容器中的应用调用的服务在宿主机、容器中都有的时候（要优先调用容器中的）,通过在查找nameList,如果能找到的话就调用set_set_destination;()
## 场景2
2.当宿主机的应用调用的服务在容器和宿主机中都有的时候（要优先调用宿主机上的），
  通过在dbus-daemon中先查找有没有本地的服务(通过查找registry),然后在查找dbus-daemon中的proxy_name_map

## 场景3
当容器中的应用提供的dbus服务是activated的时候
1. 要先判断是不是host的服务，然后判断host的可激活服务，如果有一个条件成功，那就是调用host的服务；
2. 如果第一步都不是，才是容器中提供的服务；
    - 在dbus-daemon维护的list中查找是不是容器中已经注册的服务
    - 查找配置文件是不是容器中的activated服务

## 验证

#### 场景1-普通服务

|场景|环境|结果(返回值)|
|----------------|-------------------|---------------------------|
|  docker->host  | 1.host && docker   |   docker(通过)1111 | 
|                | 2.host             |   host(通过)0 |
|                | 3.docker           |   docker(通过)1111 |
|  host->docker  | 1.host && docker   |   host(通过)0      |
|                | 2.host             |   host(通过)0
|                | 3.docker           |   docker(通过)1111 |







#### 场景2-activated服务

|场景|环境|结果(返回值)|
|----------------|-------------------|---------------------------|
|docker->host    |  1.host && docker |    docker(通过)1111        |
|                |  2.host           |    host(通过)0             |
|                |  3.docker         |    docker(通过)1111        |
|host->docker    |  1.host && docker |    host(通过)0             |  
|                |  2.host           |    host(通过)0             |
|                |  3.docker         |    docker(通过)1111        |


