import fnmatch
import subprocess
import re
import sys
import os
import threading

import shutil  
import logging

from pathlib import Path

vp_ws = "/opt/compatibility_layer/vpws" 

logger = logging.getLogger()
logger.setLevel(logging.DEBUG)

log_file = "/opt/compatibility_layer/logs/encryption.log"
file_handler = logging.FileHandler(log_file)
# formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')
formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(filename)s:%(lineno)d - %(message)s') 
file_handler.setFormatter(formatter)
logger.addHandler(file_handler)
other_service_flag = False


def pyln(src, des):
    os.system('ln -sf {} {}'.format(src, des))

# class Init():
#     # def preInit(self):
#     #     CLIST = [
#     #         "who"
#     #         "users"
#     #     ]
#     #     for each in CLIST:
#     #         DES = 
#     #         EFile = '/usr/bin/{}'.format(each)
#     #         EFileK = EFile + '-kare'
#     #         pyln(EFileK, EFile)

#     def postInit(self):
#         pyln("/usr/bin/hostAgent", "/usr/bin/xdg-open")
#         pyln("/usr/bin/hostAgent", "/usr/bin/gvfs-open")
#         pyln("/usr/bin/hostAgent", "/usr/bin/gio")
#         pyln("/usr/bin/python2", "/usr/bin/python")
#         browser_list = [  
#             "/usr/bin/firefox",  
#             "/usr/bin/firefox-esr",  
#             "/usr/bin/google-chrome-stable",  
#             "/usr/bin/chromium-browser",  
#             "/usr/bin/lbrowser",  
#             "/usr/bin/browser360-cn-stable",  
#             "/usr/bin/qaxbrowser-safe-stable"  
#         ]
#         for browser in browser_list:  
#             if not os.path.isfile(browser):
#                 pyln("/usr/bin/hostAgent", browser)
#         if not os.path.isdir("/root"):  
#             os.system("mkdir /root")

# class KareApt():

#     def __init__(self, deb):
#         self.whitelist_package={
#            "biometric-driver-huahom-im20u": ["biometric-driver-community-multidevice"],
#             "semaisystem": ["libglu1-mesa"],
#             "wpsoffice": ["libglu1-mesa"],
#             "redisplus": ["xdg-utils"],
#             "deli-printer-a113":["libsane1"],
#         }
#         self.blacklist = ["libqt5gui5-gles", "libqt5quick5-gles", "libqt5quickparticles5-gles", "kde-cli-tools", "kde-runtime", "libjack0", "libglu1"]
#         self.depends_version_dict = {}
#         self.apt_list=[]
#         self.deb = deb
#         self.log = deb.rsplit("/")[-1] + "_log"

#     def update(self):
#         os.system("apt update")
        
#     def tail(self):
#         os.system('touch /var/{}'.format(self.log))
#         os.system('tail -f /var/{}'.format(self.log))

#     def lower_apt(self, target, version):
#         for T in target.split("\n"):
#             if T.strip().startswith("500"):
#                 continue
#             else:
#                 # now = T.strip().strip(" 500").strip("*** ")
#                 now = T.strip().strip("*** ").split("500")[0].strip()
#                 ret = subprocess.getoutput("dpkg --compare-versions {} le {} && echo True".format(now, version.strip("<").strip("=")))
#                 if ret == "True":
#                     return now
#         else:
#             return False

#     def apt(self, deb):
#         ret = subprocess.getoutput('DEBIAN_FRONTEND=noninteractive apt-get -f install -y {} -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" | tee -a /var/{} '.format(deb, self.log))
#         if "下列软件包有未满足的依赖关系：" in ret:
#             for i in ret.split("下列软件包有未满足的依赖关系：")[-1].strip().split("\n")[0:-1]:
#                 if "依赖" in i:
#                     depend = i.split("依赖: ")[-1].split(" ")[0].strip()
#                     try:
#                         version = re.findall(r'\((.*?)\)', i)[0]
#                     except IndexError:
#                         version = ">"
#                     if version.startswith(">"):
#                         self.apt(depend)
#                     elif version.startswith("<"):
#                         policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
#                         ver = self.lower_apt(policy, version)
#                         if ver:
#                             self.apt(depend+"="+ver)
#                     else:
#                         # x = subprocess.getoutput("apt-cache policy {} | grep '{}'".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip()
#                         x = subprocess.getoutput("apt-cache policy {} | grep '{}'\ ".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip()
#                         self.apt(depend+"="+x)
#             os.system('DEBIAN_FRONTEND=noninteractive apt-get -f install -y {} -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" '.format(deb))
#         elif "在处理时有错误发生：" in ret or "无法找到文件 - " in ret and "错误:" in ret:
#             sys.exit(-1)

#     def set_depend_version(self, depend, version):
#         if depend.strip() in self.blacklist:
#             return
#         if version is None:
#             policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
#             if policy:
#                 self.depends_version_dict.setdefault(depend, None)
#             return
#         if version.startswith(">"):
#             policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
#             if policy:
#                 self.depends_version_dict.setdefault(depend, None)
#             return
#         elif version.startswith("<"):
#             #TODO set version
#             policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
#             ver = self.lower_apt(policy, version)
#             if ver:
#                 self.depends_version_dict[depend] = ver
#             return  
#         else:
#             # x = subprocess.getoutput("apt-cache policy {} | grep '{}'".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip()
#             x = subprocess.getoutput("apt-cache policy {} | grep '{}'".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip().split("\n")[-1].strip()
#             self.depends_version_dict.setdefault(depend, x)
#             return

#     def get_deb_depends_version(self, debs):
#         for i in debs:
#             v = None
#             pkg = i.strip()
#             if "|" in pkg:
#                 pkgs = pkg.split("|")
#                 for p in pkgs:
#                     version = None
#                     if "(" in p:
#                         p = p.split("(")[0].strip()
#                         version = re.findall(r'\((.*?)\)', i)[0]
#                     self.set_depend_version(p, version)
#             elif "(" in pkg:
#                 pkg= pkg.split("(")[0].strip()
#                 version = re.findall(r'\((.*?)\)', i)[0]
#                 self.set_depend_version(pkg, version)
#             else:
#                 self.set_depend_version(pkg, v)

#     def build_apt(self):
#         for depends in self.depends_version_dict:
#             # if self.depends_version_dict[depends] is None:
#             if self.depends_version_dict[depends] is None or self.depends_version_dict[depends] == "":
#                 self.apt_list.append(depends)
#             else:
#                  self.apt_list.append("{}={}".format(depends, self.depends_version_dict[depends]))
         

#     def get_deb_depends(self):
#         if not os.path.isdir("/root"):  
#             os.system("mkdir /root")
#         # 依赖包安装
#         package = subprocess.getoutput("dpkg -I {} | grep Package".format(self.deb)).split(" Package:")[-1].strip()
#         if self.whitelist_package.get(package):
#             self.apt(" ".join(self.whitelist_package.get(package)))
#         debs = subprocess.getoutput("dpkg -I {} | grep Depends".format(self.deb)).split(" Depends:")[-1].split(",")
#         self.get_deb_depends_version(debs)
#         self.build_apt()
#         self.apt(" ".join(self.apt_list))
#         subprocess.getoutput("apt-get install -f -y")
#         # 目标包安装
#         # ret = os.system('SYSTEMCTL_FORCE_BUS=1 SYSTEMD_IGNORE_CHROOT=1 DEBIAN_FRONTEND=noninteractive dpkg --force-confdef --force-confold -i {} '.format(self.deb))
#         ret = os.system('SYSTEMD_IGNORE_CHROOT=1 DEBIAN_FRONTEND=noninteractive dpkg --force-confdef --force-confold -i {} '.format(self.deb))
#         if ret != 0:
#             sys.exit(-1)

class ResourceManager:
    def __init__(self, type, containerNameValue, package_file):
        self.type = type
        self.containerNameValue = containerNameValue
        self.package_file = package_file
        self.log = package_file.rsplit("/")[-1] + "_log"
        self.vpWS = "/opt/compatibility_layer/vpws" 

    def find_desktop_files(self):  
        try:  
            output = subprocess.check_output(['dpkg', '-c', self.package_file], text=True)  
        except subprocess.CalledProcessError as e:  
            print(f"Error executing dpkg -c {self.package_file}: {e}")  
            return []  
    
        desktop_files = []
        purge_desktop_files = []
        pattern = re.compile(r'\./usr/share/applications/.*\.desktop')
        for line in output.splitlines():  
                match = pattern.search(line)  
                if match:  
                    desktop_files.append(match.group(0))  

        srv_flag = 0
        if not desktop_files:
            srv_flag = 1

        auto_pattern = re.compile(r'\./etc/xdg/autostart/.*\.desktop')
        for line in output.splitlines():  
                match = auto_pattern.search(line)  
                if match:  
                    desktop_files.append(match.group(0))  

        boringcmd = []  
        compensation = 1  
        scriptName="/usr/bin/kare run"
        for eachFile in desktop_files:
            purge_desktop_files.append(eachFile.split("/")[-1])
            eachFileDir = os.path.dirname(eachFile)  
            targetDirPath = os.path.join(self.vpWS, 'vp', eachFileDir)  
            if not os.path.exists(targetDirPath):  
                os.makedirs(targetDirPath)
        
            if self.type == "docker":
                cmd = "docker cp {}:/{} {}".format(self.containerNameValue, eachFile, targetDirPath)
                logger.info(cmd)
                subprocess.getoutput(cmd)
            elif self.type == "bwrap":
                print("TODO")

            eachDesktopFile = os.path.join(self.vpWS, 'vp', eachFile) 
            with open(eachDesktopFile, 'r+', encoding='utf-8') as file:  
                content = file.read()  
                file.seek(0)  
                file.write(content.rstrip('\r\n'))  
                file.truncate()  

            with open(eachDesktopFile, 'r', encoding='utf-8') as file:  
                content = file.read()  
                exec_match = re.search(r'^Exec=(.*)$', content, re.MULTILINE)  
                icon_match = re.search(r'^Icon=(.*)$', content, re.MULTILINE)  
            
                execSegment = exec_match.group(1) if exec_match else ""  
                iconSegment = icon_match.group(1) if icon_match else ""  

                placeholder = re.findall(r"%[a-zA-Z]", execSegment)
                placeholder = " ".join(placeholder)
                logger.debug("placeholder: {}".format(placeholder))

                xdgflag = re.findall(r"(xdg-open|gvfs-open|gio open)", execSegment)
                if xdgflag:
                    logger.debug("xdgflag: {}".format(xdgflag))

                cpre_patterns = [  
                    r"^\/usr\/bin\/bash -c ",  
                    r"^\/bin\/bash -c ",  
                    r"^bash -c ",  
                    r"^sh -c ",  
                    r"^\/bin\/sh -c ",  
                    r"^\/usr\/bin\/sh -c "  
                ]  
                cpre = next((re.match(p, execSegment) for p in cpre_patterns if re.match(p, execSegment)), None)  
                
                execSegmentDropPlaceholder = re.sub(r"\s%[a-zA-Z]$", "", execSegment)  
                logger.debug("pre execSegmentDropPlaceholder: {}".format(execSegmentDropPlaceholder))
                if placeholder:  
                    execSegmentDropPlaceholder = re.sub(r"(\s-[a-zA-Z])$", "", execSegmentDropPlaceholder)  
                if cpre:  
                    execSegmentDropPlaceholder = re.sub(f"^{cpre.group(0)}", "", execSegmentDropPlaceholder)  
                logger.debug("post execSegmentDropPlaceholder: {}".format(execSegmentDropPlaceholder))
                
                execTmp1 = re.sub(r"^\/usr\/bin\/bash -c |\/bin\/bash -c |bash -c |sh -c |\/bin\/sh -c |\/usr\/bin\/sh -c ", "", execSegment)  
                execTmp1 = re.sub(r"^\/usr\/bin\/bash |\/bin\/bash |bash |sh |\/bin\/sh |\/usr\/bin\/sh ", "", execTmp1)  
                execTmp2 = re.sub(r"\s%[a-zA-Z]$", "", execTmp1)  
                execCmdLn = execTmp2.split()[0]  
                if execCmdLn.endswith("\\"):  
                    execCmdLn = execCmdLn[:-1]  
                if execCmdLn.startswith('"') or execCmdLn.startswith("'"):  
                    execCmdLn = execCmdLn.strip('"\'') 
                logger.debug("execCmdLn: {}".format(execCmdLn))
                execAidDirLn = os.path.dirname(execCmdLn)
                execFileLn = os.path.basename(execCmdLn)

                lnFlag = False
                result = shutil.which(execFileLn)
                if result is None:
                    lnFlag = True
                
                if not execAidDirLn.startswith('/'):
                    execAidDirLn = "./usr/bin/"
                else:
                    execAidDirLn += '/'
                    execAidDirLn = "." + execAidDirLn

                execCmdLn = os.path.join(execAidDirLn, execFileLn)
                logger.debug("execAidDirLn: {}".format(execAidDirLn))
                logger.debug("execCmdLn: {}".format(execCmdLn))

                if "xdg-open" in execSegment or "gvfs-open" in execSegment or "gio open" in execSegment:  
                    if not os.path.exists("/sysroot"):  
                        continue
                    else:
                        logger.info("处理不可变系统中的 xdg-open")
                        # xdgfile = re.sub(r"(xdg-open|gvfs-open|gio open)\s", "", execSegment) 
                        xdgfile = execSegment.split("open ")[1]
                        logger.debug("xdgfile: {}".format(xdgfile))
                        # xdgtargetfile = re.sub(r"file://", "", execSegment)
                        xdgtargetfile = xdgfile.replace("file://", "")
                        logger.debug("xdgtargetfile: {}".format(xdgtargetfile))

                        if xdgtargetfile.startswith("/"):
                            xdgfilenew = "/opt/kare{}".format(xdgtargetfile)
                            logger.debug("xdgfilenew: {}".format(xdgfilenew)) 

                            with open(eachDesktopFile, 'r+') as desktop_file:  
                                content = desktop_file.read()  
                                content = re.sub(xdgtargetfile, xdgfilenew, content, flags=re.MULTILINE)  
                                logger.debug("content: {}".format(content))         
                                desktop_file.seek(0)  
                                desktop_file.write(content)  
                                desktop_file.truncate()
                        else:
                            logger.info("无需处理不可变系统中的 xdg-open")
                        continue

                # execAidDir = "/usr/bin"                  
                # if not execCmd.startswith("/"):  
                #     execCmd = os.path.join(execAidDir, execCmd)  
                # else:  
                #     execAidDir = os.path.dirname(execCmd)  
                
                # if shutil.which(execCmd) is not None:
                execCmd = "./usr/bin/{}".format(self.containerNameValue)
                execAidDir = "./usr/bin/" 
                if execCmd in boringcmd:
                    execCmd = execCmd + str(compensation)
                    compensation += 1
                boringcmd.append(execCmd)

                target_dir = os.path.join(self.vpWS, 'vp/', execAidDir)  
                execAidDirLn = os.path.join(self.vpWS, 'vp/', execAidDirLn)
                logger.debug("execAidDirLnDes: {}".format(execAidDirLn))
                lnTargetFile = os.path.join(self.vpWS, 'vp/', execCmdLn)
                logger.debug("lnTargetFile: {}".format(lnTargetFile))

                if not os.path.exists(target_dir):  
                    os.makedirs(target_dir)
                if lnFlag and not os.path.exists(execAidDirLn):
                    os.makedirs(execAidDirLn)
                target_file = os.path.join(self.vpWS, 'vp/', execCmd)
                logger.debug("-----------------------")
                logger.debug(target_dir)
                logger.debug(target_file)

                with open(target_file, 'w') as script_file:              
                    script_file.write("#!/bin/bash\n")  
                    if placeholder:  
                        script_file.write(f"{scriptName} {self.containerNameValue} {execSegmentDropPlaceholder} \"$@\"\n")  
                    else:  
                        script_file.write(f"{scriptName} {self.containerNameValue} {execSegmentDropPlaceholder}\n")  
                
                os.chmod(target_file, 0o755)  

                if lnFlag:
                    os.system('cp -p {} {}'.format(target_file, lnTargetFile))
                    logger.debug("cp -p {} {}".format(target_file, lnTargetFile))
                
                if os.path.exists("/sysroot"):  
                    exec_line = f"Exec=/opt/kare/{execCmd} {placeholder}" if placeholder else f"Exec=/opt/kare/{execCmd}"  
                else:  
                    exec_line = f"Exec=/{execCmd} {placeholder}" if placeholder else f"Exec=/{execCmd}"  
                logger.debug("exec_line: {}".format(exec_line))
                
                with open(eachDesktopFile, 'r+') as desktop_file:  
                    content = desktop_file.read()  

                    exec_pattern = r'^Exec=.*$'  
                    exec_replacement = exec_line if placeholder else re.sub(r'\s+\$@$', '', exec_line)  
                    logger.debug("exec_replacement: {}".format(exec_replacement))
                    content = re.sub(exec_pattern, exec_replacement, content, flags=re.MULTILINE)  
                    logger.debug("content: {}".format(content))

                    if os.path.exists("/sysroot"):  
                        if iconSegment.startswith("/"):  
                            icon_pattern = r'^Icon=.*$'  
                            icon_replacement = f'Icon=/opt/kare{iconSegment}'  
                            content = re.sub(icon_pattern, icon_replacement, content, flags=re.MULTILINE) 

                    content = re.sub(r'^DBusActivatable=true$', '#DBusActivatable=true', content, flags=re.MULTILINE)  
                    content = re.sub(r'^TryExec=.*$', '#TryExec=', content, flags=re.MULTILINE)  
                    desktop_file.seek(0)  
                    desktop_file.write(content)  
                    desktop_file.truncate()

        return srv_flag
            
    def find_icon_files(self): 

        pattern_icons = re.compile(r'\./(usr/share/icons|usr/share/.*/icons|usr/share/pixmaps)/(.*\.(png|svg|xpm))$', re.IGNORECASE)  
        icons_list = []  
        
        try:  
            output = subprocess.check_output(['dpkg', '-c', self.package_file], text=True)  
            for line in output.splitlines():  
                match = pattern_icons.search(line)  
                if match:  
                    icons_list.append(match.group(0))                        
            
            if not icons_list:  
                pattern_general = re.compile(r'\./(usr/share/)(.*\.(png|svg|xpm))$', re.IGNORECASE)  
                for line in output.splitlines():  
                    if not line.startswith('l'):  
                        match = pattern_general.search(line)  
                        if match:  
                            icons_list.append(match.group(0))  
        except subprocess.CalledProcessError as e:  
            print(f"Error executing dpkg -c: {e}")  
            return []  
    
        for eachIconFile in icons_list:  
            eachIconDir = os.path.dirname(eachIconFile)  
            targetDirPath = os.path.join(self.vpWS, 'vp', eachIconDir)  
            if not os.path.exists(targetDirPath):  
                os.makedirs(targetDirPath)

            if self.type == "docker":
                cmd = "docker cp {}:/{} {}".format(self.containerNameValue, eachIconFile, targetDirPath)
                logger.info(cmd)
                subprocess.getoutput(cmd)
            elif self.type == "bwrap":
                print("TODO")
        
    
    def find_html_files(self):
        result = subprocess.run(['dpkg', '-c', self.package_file], stdout=subprocess.PIPE, text=True)  
        if result.returncode != 0:  
            raise Exception("dpkg -c command failed")  
    
        # 使用正则表达式匹配HTML文件名  
        html_files = []  
        pattern = re.compile(r'([\.\/a-zA-Z_a-zA-Z]+\.html)$', re.IGNORECASE)
        for line in result.stdout.splitlines():  
            match = pattern.search(line)  
            if match:  
                html_files.append(match.group(1))  

        for html_file in html_files:  
            html_dir = os.path.dirname(html_file)  
            target_dir = os.path.join(self.vpWS, 'vp', html_dir)  
        
            if not os.path.exists(target_dir):  
                os.makedirs(target_dir, exist_ok=True)

            if self.type == "docker":
                cmd = "docker cp {}:/{} {}".format(self.containerNameValue, html_file, target_dir)
                logger.info(cmd)
                subprocess.getoutput(cmd)
            elif self.type == "bwrap":
                print("TODO")

    def find_udev_files(self):
        result = subprocess.run(['dpkg', '-c', self.package_file], stdout=subprocess.PIPE, text=True)  
        if result.returncode != 0:  
            raise Exception("dpkg -c command failed")  
    
        # 使用正则表达式匹配HTML文件名  
        rules_files = []  
        pattern = re.compile(r'\.\/etc\/udev\/rules\.d\/.+\.rules$', re.IGNORECASE)
        for line in result.stdout.splitlines():  
            match = pattern.search(line)  
            if match:  
                logger.debug("udev rules file match: {}".format(match))
                rules_files.append(match.group(0))  

        logger.debug("udev rules file:")
        logger.debug(rules_files)

        for rules_file in rules_files:  
            rules_dir = os.path.dirname(rules_file)  
            target_dir = os.path.join(self.vpWS, 'vp', rules_dir)  
        
            if not os.path.exists(target_dir):  
                os.makedirs(target_dir, exist_ok=True)

            if self.type == "docker":
                cmd = "docker cp {}:/{} {}".format(self.containerNameValue, rules_file, target_dir)
                logger.info(cmd)
                subprocess.getoutput(cmd)
            elif self.type == "bwrap":
                print("TODO")

    def find_service_files(self):
        # 提取systemd服务文件  
        systemd_files = subprocess.run(  
            ['dpkg-deb', '-c', self.package_file],  
            stdout=subprocess.PIPE,  
            text=True  
        ).stdout  
        standard_systemd_files = [  
            line.split()[-1] for line in systemd_files.splitlines()  
            if any(path in line for path in [  
                '/etc/systemd/system', '/lib/systemd/system', '/usr/lib/systemd/system',  
                '/etc/systemd/user', '/usr/lib/systemd/user', '/lib/systemd/user'  
            ]) and not line.endswith('/')  
        ]  

        other_systemd_files = [
            file_path for line in systemd_files.splitlines()
            for file_path in [line.split()[-1]]
            if file_path.endswith('.service') and file_path not in standard_systemd_files
        ]

        if not standard_systemd_files or not other_systemd_files:  
            return  
    
        # 设置解压路径  
        unpack_path = "/var/opt/kare/unpack_{}".format(self.containerNameValue) if os.path.exists("/sysroot") else "/tmp/unpack_{}".format(self.containerNameValue) 

        try:  
            command = ['dpkg-deb', '-x', self.package_file, unpack_path]              
            logger.info(command)
            subprocess.run(command, check=True, stdout=subprocess.DEVNULL, stderr=subprocess.DEVNULL)              
        except:  
            logger.info("fail")

        if standard_systemd_files:
            # 查找并处理系统服务文件  
            system_service_dirs = [  
                Path(unpack_path) / 'etc/systemd/system',  
                Path(unpack_path) / 'lib/systemd/system',  
                Path(unpack_path) / 'usr/lib/systemd/system'  
            ]  
            system_service_files = [f for d in system_service_dirs for f in d.glob('**/*.service')]  
            logger.debug(system_service_files)
            self.process_service_files(unpack_path, system_service_files)  
        
            # 查找并处理用户服务文件  
            user_service_dirs = [  
                Path(unpack_path) / 'etc/systemd/user',  
                Path(unpack_path) / 'lib/systemd/user',  
                Path(unpack_path) / 'usr/lib/systemd/user'  
            ]  
            user_service_files = [f for d in user_service_dirs for f in d.glob('**/*.service')]  
            self.process_service_files(unpack_path, user_service_files)  

        if other_systemd_files:
            other_service_flag = True
            # 查找并处理其他安装位置的服务文件
            other_services_files = []
            for root, dirs, files in os.walk(unpack_path):
                for filename in files:
                    # 检查文件名是否以.service结尾
                    if fnmatch.fnmatch(filename, '*.service'):
                        file_path = os.path.join(root, filename)
                        # 检查文件是否不在system_service_files和user_service_files列表中
                        if file_path not in system_service_files and file_path not in user_service_files:
                            other_services_files.append(file_path)
        self.process_service_files(unpack_path, other_services_files)  
        # 清理解压目录
        shutil.rmtree(unpack_path)  

    def process_service_files(self, unpack_path, files):  
        imutable_prefix = '/var/opt/kare'
        for file in files:  
            file_path = str(file)  

            # /lib/systemd/system/xxx.service
            target_path = file_path.replace(unpack_path, "")
            # /var/opt/kare/lib/systemd/system/xxx.service
            imutable_target_path = '/var/opt/kare{}'.format(target_path)  
            # /lib/systemd/system/
            target_dir = os.path.dirname(target_path)  

            logger.info(target_path)
            logger.info(imutable_target_path)
            logger.info(target_dir)

            # 检查文件是否已存在  
            if os.path.exists(target_path) or os.path.exists(imutable_target_path):  
                logger.info(f"该服务文件在系统中存在同名文件,继续安装\n")  
                continue  

            with open(file, 'r', encoding='utf-8') as f:  
                lines = f.readlines()  
        
            modified_lines = []  
            after_added = False  
        
            for line in lines:  
                if line.startswith('After'):  
                    line = line.rstrip('\n') + ' docker.service\n'  
                elif line.startswith('Description') and not after_added:  
                    modified_lines.append(line)  
                    modified_lines.append('After=docker.service\n')  
                    after_added = True  
                elif line.startswith('Exec'):  
                    # 处理 Exec 字段  
                    exec_field, original_value = re.split(r'\s*=\s*', line.strip(), maxsplit=1)  
                    modification_value = f"/usr/bin/kare run {self.containerNameValue} {original_value}"  
                    modified_lines.append(f"# {line}")  
                    modified_lines.append(f"{exec_field}={modification_value}\n")  
                else:  
                    modified_lines.append(line)  
        
            # 将修改后的内容写回文件  
            with open(file, 'w', encoding='utf-8') as f:  
                f.writelines(modified_lines)  
            
            if other_service_flag:
                install_path = '/etc/systemd/system/'
                if os.path.exists("/sysroot"):  
                    install_path = "/var/opt/kare{}".format(install_path)
            else:
                install_path = target_dir
                if os.path.exists("/sysroot"):  
                    install_path = "/var/opt/kare{}".format(target_dir)

            os.makedirs(install_path, exist_ok=True)  
            shutil.copy(file_path, install_path)  

            logger.debug("cp {} to {}".format(file_path, install_path))


class VpManager():
    def __init__(self, pkgName, pkgVersion, pkgArch, desktopValue):
        self.pkgName = pkgName
        self.pkgVersion = pkgVersion
        self.pkgArch = pkgArch
        self.desktopValue = desktopValue

    def vp_manager(self): 
        vp_debian_dir =  os.path.join(vp_ws, "vp/DEBIAN")
        vp_control_file = os.path.join(vp_debian_dir, "control")  
        vp_post_rm_file = os.path.join(vp_debian_dir, "postrm")
    
        if not os.path.exists(os.path.dirname(vp_control_file)):  
            os.makedirs(os.path.dirname(vp_control_file))
    
        with open(vp_control_file, "w") as f:  
            f.write(f"""Package: {self.pkgName}
Version: {self.pkgVersion}-kare
Architecture: {self.pkgArch}
Maintainer: zhanglin <zhanglin@kylinos.cn>  
Installed-Size: 160  
Depends: kare  
Section: misc  
Priority: optional  
Description: virtual package.  
""")  
    
        with open(vp_post_rm_file, "w") as f:  
            f.write(f"""#!/bin/bash  
    
pkgName={self.pkgName}
pkgVersion={self.pkgVersion}-kare
desktopName={self.desktopValue}

DesktopPath=/home/*/Desktop  
SYSLANG=$(export | grep -w LANG)  
if [[ "$SYSLANG" =~ "zh_CN" ]]; then  
    DesktopPath=/home/*/桌面  
elif [[ "$SYSLANG" =~ "en_US" ]]; then  
    DesktopPath=/home/*/Desktop  
fi  

for each in "$desktopName"; do  
    if ls $DesktopPath | grep -q $each; then  
        rm -f $DesktopPath/$each  
    fi  
done  
if kare -l | grep -q "$pkgName"; then  
    kare -P "$pkgName"  
fi  
""")  
        os.chmod(vp_post_rm_file, 0o755) 
        os.chdir(vp_ws)
        deb_file = f"{self.pkgName}_{self.pkgVersion}-kare_{self.pkgArch}.deb"  
        subprocess.run(["dpkg-deb", "--build", os.path.join(vp_ws, "vp"), deb_file], check=True)

class ServiceManager():

    def __init__(self, containerTypeValue, containerNameValue, pkgName, BWRAP_OPTIONS):
        self.containerTypeValue = containerTypeValue
        self.containerNameValue = containerNameValue
        self.pkgName = pkgName
        self.BWRAP_OPTIONS = BWRAP_OPTIONS

    def serviceRegistration(self):
        # Extract service files
        dpkg_deb_output = subprocess.check_output(["dpkg-deb", "-c", self.pkgName]).decode("utf-8")
        systemd_files = [line.split()[-1] for line in dpkg_deb_output.splitlines() if any(path in line for path in ['/etc/systemd/system', '/lib/systemd/system', '/usr/lib/systemd/system', '/etc/systemd/user', '/usr/lib/systemd/user', '/lib/systemd/user']) and not line.endswith('/')]
        logger.info(systemd_files)

        if not systemd_files:
            return

        for file in systemd_files:
            directory = os.path.dirname(file)
            target_directory = f"{vp_ws}/vp/{directory}"
            
            if not os.path.isdir(target_directory):
                os.makedirs(target_directory)

            if self.containerTypeValue == "docker":
                subprocess.run([self.containerTypeValue, "cp", f"{self.containerNameValue}:/{file}", target_directory])
            elif self.containerTypeValue == "bwrap":
                subprocess.run(["sudo", "/usr/bin/bwrap", "--uid", "0", "--gid", "0", *self.BWRAP_OPTIONS.split(), "cp", file, target_directory])

            if file.endswith(".service"):
                with open(f"{vp_ws}/vp/{file}", 'r', encoding='utf-8') as f:  
                    lines = f.readlines()  
            
                modified_lines = []  
                after_added = False  
            
                for line in lines:  
                    if line.startswith('After'):  
                        line = line.rstrip('\n') + ' docker.service\n'  
                    elif line.startswith('Description') and not after_added:  
                        modified_lines.append(line)  
                        modified_lines.append('After=docker.service\n')  
                        after_added = True  
                    elif line.startswith('Exec'):  
                        # 处理 Exec 字段  
                        exec_field, original_value = re.split(r'\s*=\s*', line.strip(), maxsplit=1)  
                        modification_value = f"/usr/bin/kare run {self.containerNameValue} {original_value}"  
                        modified_lines.append(f"# {line}")  
                        modified_lines.append(f"{exec_field}={modification_value}\n")  
                    else:  
                        modified_lines.append(line)  
            
                # 将修改后的内容写回文件  
                with open(f"{vp_ws}/vp/{file}", 'w', encoding='utf-8') as f:  
                    f.writelines(modified_lines)  

# if __name__ == "__main__":
#     containerTypeValue = sys.argv[1]
#     containerNameValue = sys.argv[2]
#     pkgName = sys.argv[3]
#     # BWRAP_OPTIONS = sys.argv[4]
#     # srHandle = ServiceManager(containerTypeValue, containerNameValue, pkgName, BWRAP_OPTIONS)
#     # srHandle.serviceRegistration()

#     srvmanager = ResourceManager(containerTypeValue, containerNameValue, pkgName)
#     srvmanager.find_service_files()

