#-------------------------------------------------
#
# Project created by QtCreator 2019-11-05T10:40:52
#
#-------------------------------------------------

QT       += core
QT += widgets
QT += dbus

TARGET = peony-menu-plugin-compatible-open
TEMPLATE = lib

DEFINES += PEONYMENUPLUGINCOMPATIBLEOPEN_LIBRARY

include(../common.pri)

# The following define makes your compiler emit warnings if you use
# any feature of Qt which has been marked as deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if you use deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

PKGCONFIG += peony
contains(QMAKE_HOST.arch, loongarch64){
    QMAKE_CXX = g++-8
}else{
    QMAKE_CXX = g++-9
}


CONFIG += debug link_pkgconfig plugin

SOURCES += \
        compatible-open-menu-plugin.cpp \
        dialog.cpp \
        qlog.cpp

HEADERS += \
        compatible-open-menu-plugin.h \
        dialog.h \
        peony-menu-plugin-compatible-open_global.h  \
        qlog.h

TRANSLATIONS += translations/peony-compatible-open-extension_zh_CN.ts
                #translations/peony-compatible-open-extension_tr.ts \
		#tranlsations/peony-compatible-open-extension_cs.ts

unix {
    target.path = $$[QT_INSTALL_LIBS]/peony-extensions
    INSTALLS += target
}

RESOURCES += \
    peony-menu-plugin-compatible-open.qrc

FORMS += \
    dialog.ui
