from distutils.core import setup
from Cython.Build import cythonize
import os

for path, _, filename in os.walk('encryption/python'):
    if "__pycache__" in path:
        continue
    mdm_list = list(
        map(lambda pathname: os.path.join(path, pathname), filename))

setup(name='mdm', ext_modules=cythonize(mdm_list,
                                        build_dir="build",
                                        compiler_directives={'language_level': "2", 'embedsignature': True}))
