#include "install.hpp"

class IFactory
{
protected:
    Install *pinst;
public:
    IFactory() : pinst(nullptr) {}
    virtual ~IFactory();
    virtual Install *create() = 0;
};

class DockerFactory : public IFactory
{
public:
    DockerFactory();
    ~DockerFactory() {}
    virtual Install *create() override;
};

class BwrapFactory : public IFactory
{
public:
    BwrapFactory();
    ~BwrapFactory() {}
    virtual Install *create() override;
};
