#include <QProcess>
#include <QString>
#include <string>
#include "global_var.h"

class Install
{
protected:
    bool runShellBlock(const QString &cmd, QString &ret);
    bool runShellBlock(const QString &cmd);
    void runShellDetach(const QString &cmd);
    void sedSubstitute(const QString &file, const QString &searchPattern, const QString &replacePattern);
public:
    explicit Install() {}
    virtual ~Install();
    void vpManager(const QString softwareNameValue, const QString softwareVersionNum, const QString softwareArch, const QString desktopNameList);
    virtual int container_preinit()
    {
        return 0;
    }
    virtual int container_init(const QString &pkgname)
    {
        return 0;
    }
};

class DockerInstall : public Install
{
public:
    DockerInstall();
    virtual ~DockerInstall() override;
    virtual int container_preinit() override;
    virtual int container_init(const QString &pkgname) override;
};

class BwrapInstall : public Install
{
public:
    BwrapInstall();
    virtual ~BwrapInstall() override;
};

