#include "factory.hpp"

int main(int argc, char *argv[])
{
    IFactory *operFactory = nullptr;
    if (argv[1] == "bwrap")
    {
        operFactory = new BwrapFactory();
    }
    else
    {
        operFactory = new DockerFactory();
    }
    Install *pinst = operFactory->create();
    pinst->container_init("");
    return 0;
}

