#include <QCoreApplication>
#include "factory.hpp"

/**
*@param 1. 容器类型
*@
*/

int main(int argc, char *argv[])
{
    IFactory *operFactory = nullptr;
    if (argv[1] == "docker")
    {
        operFactory = new DockerFactory();
    }
    else
    {
        operFactory = new BwrapFactory();
    }

    Install *pinst = operFactory->create();
    pinst->vpManager("pkgname", "1.0", "all", "a.desktop b.desktop");
}
