#include <QString>
#include <QDebug>
#include <QProcess>
#include <string>

#include <iostream>

void system_(QString des, QString src) {
    QString cmd = "ln -sf " + des + " " + src;
    qDebug() << "system_cmd: " << cmd;
    std::string cmd_ = cmd.toStdString();
    system(cmd_.c_str());
    return;
}

void _system_(QString des, QString src) {
    QString cmd = "echo qwer1234 | sudo -S ln -sf " + des + " " + src;
    qDebug() << "_system_cmd: " << cmd;
    std::string cmd_ = cmd.toStdString();
    system(cmd_.c_str());
    return;
}

void popen_(QString des, QString src) {
    QString cmd = "ln -sf " + des + " " + src;
    qDebug() << "popen_cmd: " << cmd;
    std::string cmd_ = cmd.toStdString();
    popen(cmd_.c_str(), "r");
    return;
}

void _popen_(QString des, QString src) {
    QString cmd = "echo qwer1234 | sudo -S ln -sf " + des + " " + src;
    qDebug() << "_popen_cmd: " << cmd;
    std::string cmd_ = cmd.toStdString();
    popen(cmd_.c_str(), "r");
    return;
}

void proc_(QString des, QString src) {
    QString cmd = "echo qwer1234 | sudo -S ln -sf " + des + " " + src;
    qDebug() << "proc_cmd: " << cmd;
    QProcess proc;
    proc.start(cmd);
    proc.waitForFinished();
    return;
}

bool runShellBlock(const QString &cmd)
{
    std::string tmp = cmd.trimmed().toStdString();
    std:: cout << "runShellBlock_cmd: " << tmp << std::endl;

    return system(tmp.c_str()) == 0;
}

int main()
{
    // system_("/usr/bin/test", "/usr/bin/test_system");
    // _system_("/usr/bin/test", "/usr/bin/test_system_");

    // popen_("/usr/bin/test", "/usr/bin/test_popen");
    // _popen_("/usr/bin/test", "/usr/bin/test_popen_");

    // proc_("/usr/bin/test", "/usr/bin/test_proc");

    QString efile = "/usr/bin/test";
    QString each = "test_proc";

    QString cs = QString("echo qwer1234 | sudo -S ln -sf %1 /usr/bin/%2").arg(efile).arg(each);

    runShellBlock(cs);


    return 0;
}
