#!/bin/bash

ENTRY_PATH=$(dirname $0)
PYTHON_PATH=${ENTRY_PATH}/python
PYTHON_LIB_PATH=${PYTHON_PATH}/lib

sudo jmpy -i "${PYTHON_PATH}" -o "${PYTHON_LIB_PATH}" -m 0

EXEDIR='/opt/compatibility_layer/bin'

PYTHON_CLIENT=${ENTRY_PATH}/client-py/*.py
sudo chmod 4755 $PYTHON_CLIENT
PYTHON_LIB_FILE=${PYTHON_LIB_PATH}/*.so

sudo cp -p $PYTHON_CLIENT $PYTHON_LIB_FILE $EXEDIR
